<template>
  <div id ="container">  
    <gmap-map ref="map"
      :center="center"
      :zoom="12"
      style="width:80%;  height: 700px; margin:auto;"
    >
      <GmapMarker
        :key="index"
        v-for="(marker,index) in markers"
        :position="marker"
        @click="toggleInfoWindow(marker,index)"
      ></GmapMarker>

      <gmap-info-window
        :options="infoOptions"
        :position="infoWindowPos"
        :opened="infoWinOpen"
        @closeclick="infoWinOpen=false"
      >
      <div v-html="infoContent"></div>
      </gmap-info-window>

    </gmap-map>
  </div>

</template>

<script>


import json from '@/data.json'

export default {
  name: "GoogleMap",
  map: "map",
  
  data() {
    return {
      
      center: { lat: 45.508, lng: -73.587 },
      markers: [
         {
         lat:'',
         lng:'',
         name:'',
         month:'',
         country:'',
         probability: '',
         img: ''
         
      }],
      icon: '',
      infoWindows: [],
      places: [],
      currentPlace: null,
      map: {},
      // spots: [{
      //    lat:'',
      //    long:''
      // }],
      spots: json,
      
      infoContent: '',
      infoWindowPos: {
          lat: 0,
          lng: 0
        },
      infoWinOpen: false,
      currentMidx: null,
      infoOptions: {
         pixelOffset: {
            width: 0,
            height: -35
          }
      }
}
},

  mounted() {
    this.geolocate();

    // this.$http.get('https://5ddbb358041ac10014de140b.mockapi.io/spot').then(response =>
    //   { this.spots = response.body;
    //     this.addMarker();
    //   });
    this.addMarker();
  },
 
  methods: {
    
    addMarker() {
    
       this.markers = [];
       this.spots.forEach(spot => {this.markers.push({lng: parseFloat(spot.long),
                                                      lat: parseFloat(spot.lat),
                                                      name: spot.name, 
                                                      month: spot.month,
                                                      country: spot.country,
                                                      probability: spot.probability,
                                                      });
                          }); 
  },

    toggleInfoWindow (marker, idx) {
        
        this.infoWindowPos ={lng: parseFloat(marker.lng),
                             lat: parseFloat(marker.lat)}
        
        this.infoContent = this.getInfoWindowContent(marker);
        
        if (this.currentMidx == idx) {
          this.infoWinOpen = !this.infoWinOpen;
        }else {
          this.infoWinOpen = true;
          this.currentMidx = idx;
        }  
  },
    changePin(marker){
        console.log("adwadwa");
        // marker.icon = '@/assets/img.png';
        },

    getInfoWindowContent: function (marker) {
        return (`<div class="card" style=" background-color: rgb(187, 225, 235);">
                   <div  style="font-size:30px;font-weight: bold; background-color: white; ">${marker.name}</div>
                   <div >
                      <div style="font-size:25px; color:gray;background-color: white;">${marker.country}</div>
                      <p style="font-size:17px; color:black;">LATITUDE<br>${marker.lat}<br>
                      <br>LONGITUDE<br>${marker.lng}<br>
                      <br>WHEN TO GO<br>${marker.month}</p>
                      
                    </div>
                    <div >
                    <button style="width:100%;height: 30px; " @click="changePin(marker)" >Add to Favorites
                    <style>button{ background-color: rgb(186, 218, 248);} button:hover {background-color: rgb(190, 155, 248);}</style>
                    </button>
                   
		                  </div>
                  </div>
                  
                  </div>`   
      );        
  },
    
    geolocate: function() {
        navigator.geolocation.getCurrentPosition(position => {
         this.center = {
           lat: position.coords.latitude,
           lng: position.coords.longitude
        };
      });
    },
}
}

</script>


<style scoped>

gmap-map { 
  box-shadow: -4px 7px 7px 3px rgba(0,0,0,0.75);
  margin:auto;
  border: 1px solid black;
}

#container {
  background-color: rgb(146, 166, 255);  
} 

</style>


